
package pa195.hadoop;
        
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;

import java.io.IOException;


/**
 * A MapReduce job that sorts a text file with two columns "<word> <count>" by the count (decreasing).
 */
public class SortByFrequency {

    /**
     * The main entry point into the MapReduce job.
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        // MapReduce job configuration
        Configuration conf = new Configuration();
        Job job = Job.getInstance(conf, "ordering by the count");
        job.setJarByClass(SortByFrequency.class);
        
        job.setOutputKeyClass(IntWritable.class);
        job.setOutputValueClass(Text.class);

        job.setMapperClass(SortByFrequency.Map.class);

	// Set & implement a comparator...
        //job.setSortComparatorClass(DescendingComparator.class);

        job.setInputFormatClass(TextInputFormat.class);
        job.setOutputFormatClass(TextOutputFormat.class);

        FileInputFormat.addInputPath(job, new Path(args[0]));
        FileOutputFormat.setOutputPath(job, new Path(args[1]));

        job.waitForCompletion(true);
    }

    public static class Map extends Mapper<LongWritable, Text, IntWritable, Text> {

        private final IntWritable count = new IntWritable();
        private final Text word = new Text();
        
        @Override
        protected void map(LongWritable key, Text value, Context context) throws IOException, InterruptedException {
        }
        
    }

}
